package io.grpc.examples.streaming;

import static io.grpc.MethodDescriptor.generateFullMethodName;
import static io.grpc.stub.ClientCalls.asyncBidiStreamingCall;
import static io.grpc.stub.ClientCalls.asyncClientStreamingCall;
import static io.grpc.stub.ClientCalls.asyncServerStreamingCall;
import static io.grpc.stub.ClientCalls.asyncUnaryCall;
import static io.grpc.stub.ClientCalls.blockingServerStreamingCall;
import static io.grpc.stub.ClientCalls.blockingUnaryCall;
import static io.grpc.stub.ClientCalls.futureUnaryCall;
import static io.grpc.stub.ServerCalls.asyncBidiStreamingCall;
import static io.grpc.stub.ServerCalls.asyncClientStreamingCall;
import static io.grpc.stub.ServerCalls.asyncServerStreamingCall;
import static io.grpc.stub.ServerCalls.asyncUnaryCall;
import static io.grpc.stub.ServerCalls.asyncUnimplementedStreamingCall;
import static io.grpc.stub.ServerCalls.asyncUnimplementedUnaryCall;

/**
 * <pre>
 * Interface exported by the server.
 * </pre>
 */
@javax.annotation.Generated(
    value = "by gRPC proto compiler (version 1.20.0)",
    comments = "Source: streaming.proto")
public final class StreamingGrpc {

  private StreamingGrpc() {}

  private static <T> io.grpc.stub.StreamObserver<T> toObserver(final io.vertx.core.Handler<io.vertx.core.AsyncResult<T>> handler) {
    return new io.grpc.stub.StreamObserver<T>() {
      private volatile boolean resolved = false;
      @Override
      public void onNext(T value) {
        if (!resolved) {
          resolved = true;
          handler.handle(io.vertx.core.Future.succeededFuture(value));
        }
      }

      @Override
      public void onError(Throwable t) {
        if (!resolved) {
          resolved = true;
          handler.handle(io.vertx.core.Future.failedFuture(t));
        }
      }

      @Override
      public void onCompleted() {
        if (!resolved) {
          resolved = true;
          handler.handle(io.vertx.core.Future.succeededFuture());
        }
      }
    };
  }

  public static final String SERVICE_NAME = "streaming.Streaming";

  // Static method descriptors that strictly reflect the proto.
  private static volatile io.grpc.MethodDescriptor<io.grpc.examples.streaming.Empty,
      io.grpc.examples.streaming.Item> getSourceMethod;

  public static io.grpc.MethodDescriptor<io.grpc.examples.streaming.Empty,
      io.grpc.examples.streaming.Item> getSourceMethod() {
    io.grpc.MethodDescriptor<io.grpc.examples.streaming.Empty, io.grpc.examples.streaming.Item> getSourceMethod;
    if ((getSourceMethod = StreamingGrpc.getSourceMethod) == null) {
      synchronized (StreamingGrpc.class) {
        if ((getSourceMethod = StreamingGrpc.getSourceMethod) == null) {
          StreamingGrpc.getSourceMethod = getSourceMethod = 
              io.grpc.MethodDescriptor.<io.grpc.examples.streaming.Empty, io.grpc.examples.streaming.Item>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.SERVER_STREAMING)
              .setFullMethodName(generateFullMethodName(
                  "streaming.Streaming", "Source"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  io.grpc.examples.streaming.Empty.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  io.grpc.examples.streaming.Item.getDefaultInstance()))
                  .setSchemaDescriptor(new StreamingMethodDescriptorSupplier("Source"))
                  .build();
          }
        }
     }
     return getSourceMethod;
  }

  private static volatile io.grpc.MethodDescriptor<io.grpc.examples.streaming.Item,
      io.grpc.examples.streaming.Empty> getSinkMethod;

  public static io.grpc.MethodDescriptor<io.grpc.examples.streaming.Item,
      io.grpc.examples.streaming.Empty> getSinkMethod() {
    io.grpc.MethodDescriptor<io.grpc.examples.streaming.Item, io.grpc.examples.streaming.Empty> getSinkMethod;
    if ((getSinkMethod = StreamingGrpc.getSinkMethod) == null) {
      synchronized (StreamingGrpc.class) {
        if ((getSinkMethod = StreamingGrpc.getSinkMethod) == null) {
          StreamingGrpc.getSinkMethod = getSinkMethod = 
              io.grpc.MethodDescriptor.<io.grpc.examples.streaming.Item, io.grpc.examples.streaming.Empty>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.CLIENT_STREAMING)
              .setFullMethodName(generateFullMethodName(
                  "streaming.Streaming", "Sink"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  io.grpc.examples.streaming.Item.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  io.grpc.examples.streaming.Empty.getDefaultInstance()))
                  .setSchemaDescriptor(new StreamingMethodDescriptorSupplier("Sink"))
                  .build();
          }
        }
     }
     return getSinkMethod;
  }

  private static volatile io.grpc.MethodDescriptor<io.grpc.examples.streaming.Item,
      io.grpc.examples.streaming.Item> getPipeMethod;

  public static io.grpc.MethodDescriptor<io.grpc.examples.streaming.Item,
      io.grpc.examples.streaming.Item> getPipeMethod() {
    io.grpc.MethodDescriptor<io.grpc.examples.streaming.Item, io.grpc.examples.streaming.Item> getPipeMethod;
    if ((getPipeMethod = StreamingGrpc.getPipeMethod) == null) {
      synchronized (StreamingGrpc.class) {
        if ((getPipeMethod = StreamingGrpc.getPipeMethod) == null) {
          StreamingGrpc.getPipeMethod = getPipeMethod = 
              io.grpc.MethodDescriptor.<io.grpc.examples.streaming.Item, io.grpc.examples.streaming.Item>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.BIDI_STREAMING)
              .setFullMethodName(generateFullMethodName(
                  "streaming.Streaming", "Pipe"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  io.grpc.examples.streaming.Item.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  io.grpc.examples.streaming.Item.getDefaultInstance()))
                  .setSchemaDescriptor(new StreamingMethodDescriptorSupplier("Pipe"))
                  .build();
          }
        }
     }
     return getPipeMethod;
  }

  /**
   * Creates a new async stub that supports all call types for the service
   */
  public static StreamingStub newStub(io.grpc.Channel channel) {
    return new StreamingStub(channel);
  }

  /**
   * Creates a new blocking-style stub that supports unary and streaming output calls on the service
   */
  public static StreamingBlockingStub newBlockingStub(
      io.grpc.Channel channel) {
    return new StreamingBlockingStub(channel);
  }

  /**
   * Creates a new ListenableFuture-style stub that supports unary calls on the service
   */
  public static StreamingFutureStub newFutureStub(
      io.grpc.Channel channel) {
    return new StreamingFutureStub(channel);
  }

  /**
   * Creates a new vertx stub that supports all call types for the service
   */
  public static StreamingVertxStub newVertxStub(io.grpc.Channel channel) {
    return new StreamingVertxStub(channel);
  }

  /**
   * <pre>
   * Interface exported by the server.
   * </pre>
   */
  public static abstract class StreamingImplBase implements io.grpc.BindableService {

    /**
     */
    public void source(io.grpc.examples.streaming.Empty request,
        io.grpc.stub.StreamObserver<io.grpc.examples.streaming.Item> responseObserver) {
      asyncUnimplementedUnaryCall(getSourceMethod(), responseObserver);
    }

    /**
     */
    public io.grpc.stub.StreamObserver<io.grpc.examples.streaming.Item> sink(
        io.grpc.stub.StreamObserver<io.grpc.examples.streaming.Empty> responseObserver) {
      return asyncUnimplementedStreamingCall(getSinkMethod(), responseObserver);
    }

    /**
     */
    public io.grpc.stub.StreamObserver<io.grpc.examples.streaming.Item> pipe(
        io.grpc.stub.StreamObserver<io.grpc.examples.streaming.Item> responseObserver) {
      return asyncUnimplementedStreamingCall(getPipeMethod(), responseObserver);
    }

    @java.lang.Override public final io.grpc.ServerServiceDefinition bindService() {
      return io.grpc.ServerServiceDefinition.builder(getServiceDescriptor())
          .addMethod(
            getSourceMethod(),
            asyncServerStreamingCall(
              new MethodHandlers<
                io.grpc.examples.streaming.Empty,
                io.grpc.examples.streaming.Item>(
                  this, METHODID_SOURCE)))
          .addMethod(
            getSinkMethod(),
            asyncClientStreamingCall(
              new MethodHandlers<
                io.grpc.examples.streaming.Item,
                io.grpc.examples.streaming.Empty>(
                  this, METHODID_SINK)))
          .addMethod(
            getPipeMethod(),
            asyncBidiStreamingCall(
              new MethodHandlers<
                io.grpc.examples.streaming.Item,
                io.grpc.examples.streaming.Item>(
                  this, METHODID_PIPE)))
          .build();
    }
  }

  /**
   * <pre>
   * Interface exported by the server.
   * </pre>
   */
  public static final class StreamingStub extends io.grpc.stub.AbstractStub<StreamingStub> {
    public StreamingStub(io.grpc.Channel channel) {
      super(channel);
    }

    public StreamingStub(io.grpc.Channel channel,
        io.grpc.CallOptions callOptions) {
      super(channel, callOptions);
    }

    @java.lang.Override
    protected StreamingStub build(io.grpc.Channel channel,
        io.grpc.CallOptions callOptions) {
      return new StreamingStub(channel, callOptions);
    }

    /**
     */
    public void source(io.grpc.examples.streaming.Empty request,
        io.grpc.stub.StreamObserver<io.grpc.examples.streaming.Item> responseObserver) {
      asyncServerStreamingCall(
          getChannel().newCall(getSourceMethod(), getCallOptions()), request, responseObserver);
    }

    /**
     */
    public io.grpc.stub.StreamObserver<io.grpc.examples.streaming.Item> sink(
        io.grpc.stub.StreamObserver<io.grpc.examples.streaming.Empty> responseObserver) {
      return asyncClientStreamingCall(
          getChannel().newCall(getSinkMethod(), getCallOptions()), responseObserver);
    }

    /**
     */
    public io.grpc.stub.StreamObserver<io.grpc.examples.streaming.Item> pipe(
        io.grpc.stub.StreamObserver<io.grpc.examples.streaming.Item> responseObserver) {
      return asyncBidiStreamingCall(
          getChannel().newCall(getPipeMethod(), getCallOptions()), responseObserver);
    }
  }

  /**
   * <pre>
   * Interface exported by the server.
   * </pre>
   */
  public static final class StreamingBlockingStub extends io.grpc.stub.AbstractStub<StreamingBlockingStub> {
    public StreamingBlockingStub(io.grpc.Channel channel) {
      super(channel);
    }

    public StreamingBlockingStub(io.grpc.Channel channel,
        io.grpc.CallOptions callOptions) {
      super(channel, callOptions);
    }

    @java.lang.Override
    protected StreamingBlockingStub build(io.grpc.Channel channel,
        io.grpc.CallOptions callOptions) {
      return new StreamingBlockingStub(channel, callOptions);
    }

    /**
     */
    public java.util.Iterator<io.grpc.examples.streaming.Item> source(
        io.grpc.examples.streaming.Empty request) {
      return blockingServerStreamingCall(
          getChannel(), getSourceMethod(), getCallOptions(), request);
    }
  }

  /**
   * <pre>
   * Interface exported by the server.
   * </pre>
   */
  public static final class StreamingFutureStub extends io.grpc.stub.AbstractStub<StreamingFutureStub> {
    public StreamingFutureStub(io.grpc.Channel channel) {
      super(channel);
    }

    public StreamingFutureStub(io.grpc.Channel channel,
        io.grpc.CallOptions callOptions) {
      super(channel, callOptions);
    }

    @java.lang.Override
    protected StreamingFutureStub build(io.grpc.Channel channel,
        io.grpc.CallOptions callOptions) {
      return new StreamingFutureStub(channel, callOptions);
    }
  }

  /**
   * <pre>
   * Interface exported by the server.
   * </pre>
   */
  public static abstract class StreamingVertxImplBase implements io.grpc.BindableService {

    /**
     */
    public void source(io.grpc.examples.streaming.Empty request,
        io.vertx.grpc.GrpcWriteStream<io.grpc.examples.streaming.Item> response) {
      asyncUnimplementedUnaryCall(getSourceMethod(), response.writeObserver());
    }

    /**
     */
    public void sink(io.vertx.grpc.GrpcReadStream<io.grpc.examples.streaming.Item> request,
        io.vertx.core.Future<io.grpc.examples.streaming.Empty> response) {
      request.setReadObserver(asyncUnimplementedStreamingCall(getSinkMethod(), StreamingGrpc.toObserver(response)));
    }

    /**
     */
    public void pipe(
        io.vertx.grpc.GrpcBidiExchange<io.grpc.examples.streaming.Item, io.grpc.examples.streaming.Item> exchange) {
      exchange.setReadObserver(asyncUnimplementedStreamingCall(getPipeMethod(), exchange.writeObserver()));
    }

    @java.lang.Override public final io.grpc.ServerServiceDefinition bindService() {
      return io.grpc.ServerServiceDefinition.builder(getServiceDescriptor())
          .addMethod(
            getSourceMethod(),
            asyncServerStreamingCall(
              new VertxMethodHandlers<
                io.grpc.examples.streaming.Empty,
                io.grpc.examples.streaming.Item>(
                  this, METHODID_SOURCE)))
          .addMethod(
            getSinkMethod(),
            asyncClientStreamingCall(
              new VertxMethodHandlers<
                io.grpc.examples.streaming.Item,
                io.grpc.examples.streaming.Empty>(
                  this, METHODID_SINK)))
          .addMethod(
            getPipeMethod(),
            asyncBidiStreamingCall(
              new VertxMethodHandlers<
                io.grpc.examples.streaming.Item,
                io.grpc.examples.streaming.Item>(
                  this, METHODID_PIPE)))
          .build();
    }
  }

  /**
   * <pre>
   * Interface exported by the server.
   * </pre>
   */
  public static final class StreamingVertxStub extends io.grpc.stub.AbstractStub<StreamingVertxStub> {
    public StreamingVertxStub(io.grpc.Channel channel) {
      super(channel);
    }

    public StreamingVertxStub(io.grpc.Channel channel,
        io.grpc.CallOptions callOptions) {
      super(channel, callOptions);
    }

    @java.lang.Override
    protected StreamingVertxStub build(io.grpc.Channel channel,
        io.grpc.CallOptions callOptions) {
      return new StreamingVertxStub(channel, callOptions);
    }

    /**
     */
    public void source(io.grpc.examples.streaming.Empty request,
        io.vertx.core.Handler<io.vertx.grpc.GrpcReadStream<io.grpc.examples.streaming.Item>> handler) {
      final io.vertx.grpc.GrpcReadStream<io.grpc.examples.streaming.Item> readStream =
          io.vertx.grpc.GrpcReadStream.<io.grpc.examples.streaming.Item>create();

      handler.handle(readStream);
      asyncServerStreamingCall(
          getChannel().newCall(getSourceMethod(), getCallOptions()), request, readStream.readObserver());
    }

    /**
     */
    public void sink(io.vertx.core.Handler<
        io.vertx.grpc.GrpcUniExchange<io.grpc.examples.streaming.Item, io.grpc.examples.streaming.Empty>> handler) {
      final io.vertx.grpc.GrpcReadStream<io.grpc.examples.streaming.Empty> readStream =
          io.vertx.grpc.GrpcReadStream.<io.grpc.examples.streaming.Empty>create();

      handler.handle(io.vertx.grpc.GrpcUniExchange.create(readStream, asyncClientStreamingCall(
          getChannel().newCall(getSinkMethod(), getCallOptions()), readStream.readObserver())));
    }

    /**
     */
    public void pipe(io.vertx.core.Handler<
        io.vertx.grpc.GrpcBidiExchange<io.grpc.examples.streaming.Item, io.grpc.examples.streaming.Item>> handler) {
      final io.vertx.grpc.GrpcReadStream<io.grpc.examples.streaming.Item> readStream =
          io.vertx.grpc.GrpcReadStream.<io.grpc.examples.streaming.Item>create();

      handler.handle(io.vertx.grpc.GrpcBidiExchange.create(readStream, asyncBidiStreamingCall(
          getChannel().newCall(getPipeMethod(), getCallOptions()), readStream.readObserver())));
    }
  }

  private static final int METHODID_SOURCE = 0;
  private static final int METHODID_SINK = 1;
  private static final int METHODID_PIPE = 2;

  private static final class MethodHandlers<Req, Resp> implements
      io.grpc.stub.ServerCalls.UnaryMethod<Req, Resp>,
      io.grpc.stub.ServerCalls.ServerStreamingMethod<Req, Resp>,
      io.grpc.stub.ServerCalls.ClientStreamingMethod<Req, Resp>,
      io.grpc.stub.ServerCalls.BidiStreamingMethod<Req, Resp> {
    private final StreamingImplBase serviceImpl;
    private final int methodId;

    MethodHandlers(StreamingImplBase serviceImpl, int methodId) {
      this.serviceImpl = serviceImpl;
      this.methodId = methodId;
    }

    @java.lang.Override
    @java.lang.SuppressWarnings("unchecked")
    public void invoke(Req request, io.grpc.stub.StreamObserver<Resp> responseObserver) {
      switch (methodId) {
        case METHODID_SOURCE:
          serviceImpl.source((io.grpc.examples.streaming.Empty) request,
              (io.grpc.stub.StreamObserver<io.grpc.examples.streaming.Item>) responseObserver);
          break;
        default:
          throw new AssertionError();
      }
    }

    @java.lang.Override
    @java.lang.SuppressWarnings("unchecked")
    public io.grpc.stub.StreamObserver<Req> invoke(
        io.grpc.stub.StreamObserver<Resp> responseObserver) {
      switch (methodId) {
        case METHODID_SINK:
          return (io.grpc.stub.StreamObserver<Req>) serviceImpl.sink(
              (io.grpc.stub.StreamObserver<io.grpc.examples.streaming.Empty>) responseObserver);
        case METHODID_PIPE:
          return (io.grpc.stub.StreamObserver<Req>) serviceImpl.pipe(
              (io.grpc.stub.StreamObserver<io.grpc.examples.streaming.Item>) responseObserver);
        default:
          throw new AssertionError();
      }
    }
  }

  private static final class VertxMethodHandlers<Req, Resp> implements
      io.grpc.stub.ServerCalls.UnaryMethod<Req, Resp>,
      io.grpc.stub.ServerCalls.ServerStreamingMethod<Req, Resp>,
      io.grpc.stub.ServerCalls.ClientStreamingMethod<Req, Resp>,
      io.grpc.stub.ServerCalls.BidiStreamingMethod<Req, Resp> {
    private final StreamingVertxImplBase serviceImpl;
    private final int methodId;

    VertxMethodHandlers(StreamingVertxImplBase serviceImpl, int methodId) {
      this.serviceImpl = serviceImpl;
      this.methodId = methodId;
    }

    @java.lang.Override
    @java.lang.SuppressWarnings("unchecked")
    public void invoke(Req request, io.grpc.stub.StreamObserver<Resp> responseObserver) {
      switch (methodId) {
        case METHODID_SOURCE:
          serviceImpl.source((io.grpc.examples.streaming.Empty) request,
              (io.vertx.grpc.GrpcWriteStream<io.grpc.examples.streaming.Item>) io.vertx.grpc.GrpcWriteStream.create(responseObserver));
          break;
        default:
          throw new AssertionError();
      }
    }

    @java.lang.Override
    @java.lang.SuppressWarnings("unchecked")
    public io.grpc.stub.StreamObserver<Req> invoke(
        io.grpc.stub.StreamObserver<Resp> responseObserver) {
      switch (methodId) {
        case METHODID_SINK:
          io.vertx.grpc.GrpcReadStream<io.grpc.examples.streaming.Item> request1 = io.vertx.grpc.GrpcReadStream.<io.grpc.examples.streaming.Item>create();
          serviceImpl.sink(request1, (io.vertx.core.Future<io.grpc.examples.streaming.Empty>) io.vertx.core.Future.<io.grpc.examples.streaming.Empty>future().setHandler(ar -> {
            if (ar.succeeded()) {
              ((io.grpc.stub.StreamObserver<io.grpc.examples.streaming.Empty>) responseObserver).onNext(ar.result());
              responseObserver.onCompleted();
            } else {
              responseObserver.onError(ar.cause());
            }
          }));
          return (io.grpc.stub.StreamObserver<Req>) request1.readObserver();
        case METHODID_PIPE:
          io.vertx.grpc.GrpcReadStream<io.grpc.examples.streaming.Item> request2 = io.vertx.grpc.GrpcReadStream.<io.grpc.examples.streaming.Item>create();
          serviceImpl.pipe(
             io.vertx.grpc.GrpcBidiExchange.<io.grpc.examples.streaming.Item, io.grpc.examples.streaming.Item>create(
               request2,
               (io.grpc.stub.StreamObserver<io.grpc.examples.streaming.Item>) responseObserver));
          return (io.grpc.stub.StreamObserver<Req>) request2.readObserver();
        default:
          throw new AssertionError();
      }
    }
  }

  private static abstract class StreamingBaseDescriptorSupplier
      implements io.grpc.protobuf.ProtoFileDescriptorSupplier, io.grpc.protobuf.ProtoServiceDescriptorSupplier {
    StreamingBaseDescriptorSupplier() {}

    @java.lang.Override
    public com.google.protobuf.Descriptors.FileDescriptor getFileDescriptor() {
      return io.grpc.examples.streaming.StreamingProto.getDescriptor();
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.ServiceDescriptor getServiceDescriptor() {
      return getFileDescriptor().findServiceByName("Streaming");
    }
  }

  private static final class StreamingFileDescriptorSupplier
      extends StreamingBaseDescriptorSupplier {
    StreamingFileDescriptorSupplier() {}
  }

  private static final class StreamingMethodDescriptorSupplier
      extends StreamingBaseDescriptorSupplier
      implements io.grpc.protobuf.ProtoMethodDescriptorSupplier {
    private final String methodName;

    StreamingMethodDescriptorSupplier(String methodName) {
      this.methodName = methodName;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.MethodDescriptor getMethodDescriptor() {
      return getServiceDescriptor().findMethodByName(methodName);
    }
  }

  private static volatile io.grpc.ServiceDescriptor serviceDescriptor;

  public static io.grpc.ServiceDescriptor getServiceDescriptor() {
    io.grpc.ServiceDescriptor result = serviceDescriptor;
    if (result == null) {
      synchronized (StreamingGrpc.class) {
        result = serviceDescriptor;
        if (result == null) {
          serviceDescriptor = result = io.grpc.ServiceDescriptor.newBuilder(SERVICE_NAME)
              .setSchemaDescriptor(new StreamingFileDescriptorSupplier())
              .addMethod(getSourceMethod())
              .addMethod(getSinkMethod())
              .addMethod(getPipeMethod())
              .build();
        }
      }
    }
    return result;
  }
}
